;(function($, window, document, undefined ){

	$.fn.wallgrid = function(options) {
        return this.each(function () {
            if (!$.data(this, "wallgrid")) {
                $.data(this, "wallgrid", new WG( this, options ));
            }
        });
	}

	var defaults = {
		width: 300,
        animate: true,
        childs: 'li',
        minCols: false,
        maxCols: false
	};


	function WG(element, options){
		this.element = element;
		this.options = $.extend( {}, defaults, options );
    	this._defaults = defaults;

    	this.init();

    	$(window).on('resize', $.proxy(this.calcul, this));
	}

	WG.prototype = {
		
		init: function(){
			var parent = this;	
			this.ALL = [];
			this.ITEMS = $(this.element).find(this.options.childs);

			if(this.ITEMS.length > 0){
				$.each(this.ITEMS, function(key, val){
					parent.ALL.push(val);
				});
			}

			this.calcul();
			
		},

		calcul: function(){
			
			this.W_W = $(window).width();
			var column = Math.round( this.W_W / this.options.width ), y = 0;

			if(this.options.minCols)
				column = Math.max( this.options.minCols, column );

			if(this.options.maxCols)
				column = Math.min( this.options.maxCols, column );


			for( var i = 0; i < this.ALL.length; i++ ){
				var current = $(this.ALL[i]),
					row = Math.floor(i/column);

				if( (y % column) == 0 ){
					y = 0;

					if( $(this.ALL[i-1]).length > 0 ) {
						$(this.ALL[i-1]).addClass('last');
					}
				}

				var s_w = Math.round( this.W_W / column );

				current.addClass('loaded').css({
					position: 'absolute',
					left: s_w * y,
					top: row * s_w,
					width: s_w,
					height: s_w
				});

				y++;

			}

			/*
			var difference = ( column * s_w ) - this.W_W;
			if(difference > 0){
				this.ITEMS.find('.last').css({
					width: (s_w - difference)-2
				});
			} */

		}

	}


})(jQuery, window, document);

$("ul").wallgrid({
	minCols: 2
});